Index: inc/public/prepend.php
===================================================================
--- inc/public/prepend.php	(revision 420)
+++ inc/public/prepend.php	(revision 921)
@@ -33,5 +33,5 @@
 				__('The following error was encountered while trying to read the database:').'</p><ul><li>'.$e->getMessage().'</li></ul>' :
 				__('Something went wrong while trying to read the database.')
-			,20);
+			,620);
 	}
 }
@@ -40,5 +40,5 @@
 	__error(__('Blog is not defined.')
 		,__('Did you change your Blog ID?')
-		,30);
+		,630);
 }
 
@@ -47,5 +47,5 @@
 	__error(__('Blog is offline.')
 		,__('This blog is offline. Please try again later.')
-		,70);
+		,670);
 }
 
@@ -62,5 +62,5 @@
 	__error(__('Can\'t create template files.')
 		,$e->getMessage()
-		,40);
+		,640);
 }
 
@@ -107,5 +107,5 @@
 		'path in your blog configuration. Please check theme_path value in '.
 		'about:config module or reinstall default theme. ('.$__theme.')')
-		,50);
+		,650);
 }
 
@@ -152,5 +152,5 @@
 	__error($e->getMessage()
 		,__('Something went wrong while loading template file for your blog.')
-		,60);
+		,660);
 }
 ?>
Index: locales/po_update.sh
===================================================================
--- locales/po_update.sh	(revision 750)
+++ locales/po_update.sh	(revision 959)
@@ -172,5 +172,5 @@
 	find $PO_MODULE -name '*.html' -exec grep -o '{{tpl:lang [^}]*}}' {} \; | sed 's/{{tpl:lang \(.*\)}}$/__\("\1")/' | sort -u \
 		>> $PO_MODULE/__html_tpl_dummy.php
-	sed -i 's/\$/\\\$/g' $PO_MODULE/__html_tpl_dummy.php 
+	sed -i "" 's/\$/\\\$/g' $PO_MODULE/__html_tpl_dummy.php 
 	
 	find $PO_MODULE -name '*.php' -print | \
Index: plugins/aboutConfig/_define.php
===================================================================
--- plugins/aboutConfig/_define.php	(revision 589)
+++ plugins/aboutConfig/_define.php	(revision 967)
@@ -16,5 +16,5 @@
 	/* Description*/		"Manage every blog configuration directive",
 	/* Author */			"Olivier Meunier",
-	/* Version */			'0.4'
+	/* Version */			'0.5'
 );
 ?>
Index: plugins/aboutConfig/index.php
===================================================================
--- plugins/aboutConfig/index.php	(revision 589)
+++ plugins/aboutConfig/index.php	(revision 907)
@@ -121,9 +121,9 @@
 <?php
 if (!empty($_GET['upd'])) {
-	echo '<p class="message">'.__('Configuration successfully updated').'</p>';
+	dcPage::message(__('Configuration successfully updated'));
 }
 
 if (!empty($_GET['upda'])) {
-	echo '<p class="message">'.__('Settings definition successfully updated').'</p>';
+	dcPage::message(__('Settings definition successfully updated'));
 }
 ?>
Index: plugins/antispam/_define.php
===================================================================
--- plugins/antispam/_define.php	(revision 464)
+++ plugins/antispam/_define.php	(revision 967)
@@ -16,5 +16,5 @@
 	/* Description*/		"Generic antispam plugin for Dotclear",
 	/* Author */			"Alain Vagner",
-	/* Version */			'1.3.1',
+	/* Version */			'1.4',
 	array(
 		'permissions' =>	'usage,contentadmin',
Index: plugins/antispam/_prepend.php
===================================================================
--- plugins/antispam/_prepend.php	(revision 270)
+++ plugins/antispam/_prepend.php	(revision 920)
@@ -24,5 +24,5 @@
 $__autoload['dcFilterWords'] = dirname(__FILE__).'/filters/class.dc.filter.words.php';
 
-$core->spamfilters = array('dcFilterIP','dcFilterWords','dcFilterIpLookup','dcFilterLinksLookup');
+$core->spamfilters = array('dcFilterIP','dcFilterIpLookup','dcFilterWords','dcFilterLinksLookup');
 
 $core->url->register('spamfeed','spamfeed','^spamfeed/(.+)$',array('dcAntispamURL','spamFeed'));
Index: plugins/antispam/filters/class.dc.filter.ip.php
===================================================================
--- plugins/antispam/filters/class.dc.filter.ip.php	(revision 536)
+++ plugins/antispam/filters/class.dc.filter.ip.php	(revision 907)
@@ -103,8 +103,8 @@
 
 		if (!empty($_GET['added'])) {
-			$res .= '<p class="message">'.__('IP address has been successfully added.').'</p>';
+			$res .= dcPage::message(__('IP address has been successfully added.'),true,false,false);
 		}
 		if (!empty($_GET['removed'])) {
-			$res .= '<p class="message">'.__('IP addresses have been successfully removed.').'</p>';
+			$res .= dcPage::message(__('IP addresses have been successfully removed.'),true,false,false);
 		}
 
@@ -130,5 +130,5 @@
 		if ($core->auth->isSuperAdmin()) {
 			$res .= '<label class="classic" for="globalip_'.$type.'">'.form::checkbox(array('globalip', 'globalip_'.$type),1).' '.
-			__('Global IP').'</label> ';
+			__('Global IP (used for all blogs)').'</label> ';
 		}
 
@@ -152,4 +152,6 @@
 			'<div style="'.$this->style_list.'">';
 
+			$res_global = '';
+			$res_local = '';
 			while ($rs->fetch())
 			{
@@ -166,10 +168,26 @@
 				}
 
-				$res .=
+				$item =
 				'<p style="'.$p_style.'"><label class="classic" for="'.$type.'-ip-'.$rs->rule_id.'">'.
 				form::checkbox(array('delip[]',$type.'-ip-'.$rs->rule_id),$rs->rule_id,false,'','',$disabled_ip).' '.
 				html::escapeHTML($pattern).
 				'</label></p>';
-			}
+
+				if ($rs->blog_id) {
+					// local list
+					if ($res_local == '') {
+						$res_local = '<h4>'.__('Local IPs (used only for this blog)').'</h4>';
+					}
+					$res_local .= $item;
+				} else {
+					// global list
+					if ($res_global == '') {
+						$res_global = '<h4>'.__('Global IPs (used for all blogs)').'</h4>';
+					}
+					$res_global .= $item;
+				}
+			}
+			$res .= $res_local.$res_global;
+
 			$res .=
 			'</div>'.
Index: plugins/antispam/filters/class.dc.filter.linkslookup.php
===================================================================
--- plugins/antispam/filters/class.dc.filter.linkslookup.php	(revision 270)
+++ plugins/antispam/filters/class.dc.filter.linkslookup.php	(revision 913)
@@ -43,12 +43,20 @@
 				continue;
 			}
-			
-			$domain = preg_replace('/^(.*\.)([^.]+\.[^.]+)$/','$2',$b['host']);
-			$host = $domain.'.'.$this->server;
-			
-			if (gethostbyname($host) != $host) {
-				$status = substr($domain,0,128);
-				return true;
-			}
+
+			$domain = preg_replace('/^[\w]{2,6}:\/\/([\w\d\.\-]+).*$/','$1',$b['host']);
+			$domain_elem = explode(".",$domain);
+
+			$i = count($domain_elem) - 1;
+			$host = $domain_elem[$i];
+			do
+			{
+				$host = $domain_elem[$i - 1].'.'.$host;
+				$i--;
+				if (substr(gethostbyname($host.'.'.$this->server),0,3) == "127" ) 
+				{
+					$status = substr($domain,0,128);
+					return true;
+				}				
+			} while ($i > 0);
 		}
 	}
Index: plugins/antispam/filters/class.dc.filter.words.php
===================================================================
--- plugins/antispam/filters/class.dc.filter.words.php	(revision 536)
+++ plugins/antispam/filters/class.dc.filter.words.php	(revision 907)
@@ -109,11 +109,11 @@
 
 		if (!empty($_GET['list'])) {
-			$res .= '<p class="message">'.__('Words have been successfully added.').'</p>';
+			$res .= dcPage::message(__('Words have been successfully added.'),true,false,false);
 		}
 		if (!empty($_GET['added'])) {
-			$res .= '<p class="message">'.__('Word has been successfully added.').'</p>';
+			$res .= dcPage::message(__('Word has been successfully added.'),true,false,false);
 		}
 		if (!empty($_GET['removed'])) {
-			$res .= '<p class="message">'.__('Words have been successfully removed.').'</p>';
+			$res .= dcPage::message(__('Words have been successfully removed.'),true,false,false);
 		}
 
@@ -124,5 +124,5 @@
 		if ($core->auth->isSuperAdmin()) {
 			$res .= '<label class="classic" for="globalsw">'.form::checkbox('globalsw',1).' '.
-			__('Global word').'</label> ';
+			__('Global word (used for all blogs)').'</label> ';
 		}
 
@@ -145,4 +145,6 @@
 			'<div style="'.$this->style_list.'">';
 
+			$res_global = '';
+			$res_local = '';
 			while ($rs->fetch())
 			{
@@ -154,10 +156,24 @@
 				}
 
-				$res .=
-				'<p style="'.$p_style.'"><label class="classic" for="word-'.$rs->rule_id.'">'.
-				form::checkbox(array('swd[]', 'word-'.$rs->rule_id),$rs->rule_id,false,'','',$disabled_word).' '.
-				html::escapeHTML($rs->rule_content).
-				'</label></p>';
-			}
+				$item = '<p style="'.$p_style.'"><label class="classic" for="word-'.$rs->rule_id.'">'.
+					form::checkbox(array('swd[]', 'word-'.$rs->rule_id),$rs->rule_id,false,'','',$disabled_word).' '.
+					html::escapeHTML($rs->rule_content).
+					'</label></p>';
+
+				if ($rs->blog_id) {
+					// local list
+					if ($res_local == '') {
+						$res_local = '<h4>'.__('Local words (used only for this blog)').'</h4>';
+					}
+					$res_local .= $item;
+				} else {
+					// global list
+					if ($res_global == '') {
+						$res_global = '<h4>'.__('Global words (used for all blogs)').'</h4>';
+					}
+					$res_global .= $item;
+				}
+			}
+			$res .= $res_local.$res_global;
 
 			$res .=
Index: plugins/antispam/index.php
===================================================================
--- plugins/antispam/index.php	(revision 776)
+++ plugins/antispam/index.php	(revision 907)
@@ -99,5 +99,5 @@
 <html>
 <head>
-  <title><?php echo $page_name; ?></title>
+  <title><?php echo ($filter_gui !== false ? sprintf(__('%s configuration'),$filter->name).' - ' : '').$page_name; ?></title>
   <?php
   echo
@@ -132,5 +132,5 @@
 
 	if (!empty($_GET['del'])) {
-		echo '<p class="message">'.__('Spam comments have been successfully deleted.').'</p>';
+		dcPage::message(__('Spam comments have been successfully deleted.'));
 	}
 
@@ -163,5 +163,5 @@
 
 	if (!empty($_GET['upd'])) {
-		echo '<p class="message">'.__('Filters configuration has been successfully saved.').'</p>';
+		dcPage::message(__('Filters configuration has been successfully saved.'));
 	}
 
Index: plugins/attachments/_define.php
===================================================================
--- plugins/attachments/_define.php	(revision 843)
+++ plugins/attachments/_define.php	(revision 967)
@@ -16,5 +16,5 @@
 	/* Description*/	"Manage post attachments",
 	/* Author */		"Dotclear Team",
-	/* Version */		'1.0',
+	/* Version */		'1.1',
 	array(
 		'permissions' =>	'usage,contentadmin,pages',
Index: plugins/attachments/_public.php
===================================================================
--- plugins/attachments/_public.php	(revision 464)
+++ plugins/attachments/_public.php	(revision 944)
@@ -89,5 +89,5 @@
 		$if = array();
 		
-		$operator = isset($attr['operator']) ? $this->getOperator($attr['operator']) : '&&';
+		$operator = isset($attr['operator']) ? dcTemplate::getOperator($attr['operator']) : '&&';
 		
 		if (isset($attr['is_image'])) {
Index: plugins/blogroll/_define.php
===================================================================
--- plugins/blogroll/_define.php	(revision 464)
+++ plugins/blogroll/_define.php	(revision 965)
@@ -16,5 +16,5 @@
 	/* Description*/		"Manage your blogroll",
 	/* Author */			"Olivier Meunier",
-	/* Version */			'1.2',
+	/* Version */			'1.3',
 	array(
 		'permissions' =>	'blogroll'
Index: plugins/blogroll/_public.php
===================================================================
--- plugins/blogroll/_public.php	(revision 776)
+++ plugins/blogroll/_public.php	(revision 945)
@@ -140,5 +140,6 @@
 		global $core;
 		
-		if ($w->homeonly && $core->url->type != 'default') {
+		if (($w->homeonly == 1 && $core->url->type != 'default') ||
+			($w->homeonly == 2 && $core->url->type == 'default')) {
 			return;
 		}
@@ -151,5 +152,5 @@
 		
 		return
-		'<div class="links">'.
+		'<div class="links'.($w->class ? ' '.html::escapeHTML($w->class) : '').'">'.
 		($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').
 		$links.
Index: plugins/blogroll/_widgets.php
===================================================================
--- plugins/blogroll/_widgets.php	(revision 270)
+++ plugins/blogroll/_widgets.php	(revision 954)
@@ -19,5 +19,5 @@
 	public static function initWidgets($w)
 	{
-		$w->create('links',__('Blogroll'),array('tplBlogroll','linksWidget'));
+		$w->create('links',__('Blogroll'),array('tplBlogroll','linksWidget'),null,'Blogroll list');
 		$w->links->setting('title',__('Title:'),__('Links'));
 		
@@ -34,5 +34,12 @@
 		$w->links->setting('category',__('Category'),'','combo',$categories);
 		
-		$w->links->setting('homeonly',__('Home page only'),1,'check');
+		$w->links->setting('homeonly',__('Display on:'),1,'combo',
+			array(
+				__('All pages') => 0,
+				__('Home page only') => 1,
+				__('Except on home page') => 2
+				)
+		);
+		$w->links->setting('class',__('CSS class:'),'');
 	}
 	
Index: plugins/blogroll/edit.php
===================================================================
--- plugins/blogroll/edit.php	(revision 270)
+++ plugins/blogroll/edit.php	(revision 907)
@@ -101,5 +101,5 @@
 {
 	if (!empty($_GET['upd'])) {
-		echo '<p class="message">'.__('Category has been successfully updated').'</p>';
+		dcPage::message(__('Category has been successfully updated'));
 	}
 	
@@ -121,5 +121,5 @@
 {
 	if (!empty($_GET['upd'])) {
-		echo '<p class="message">'.__('Link has been successfully updated').'</p>';
+		dcPage::message(__('Link has been successfully updated'));
 	}
 	
Index: plugins/blogroll/index.php
===================================================================
--- plugins/blogroll/index.php	(revision 717)
+++ plugins/blogroll/index.php	(revision 907)
@@ -219,21 +219,21 @@
 <?php
 if (!empty($_GET['neworder'])) {
-	echo '<p class="message">'.__('Items order has been successfully updated').'</p>';
+	dcPage::message(__('Items order has been successfully updated'));
 }
 
 if (!empty($_GET['removed'])) {
-		echo '<p class="message">'.__('Items have been successfully removed.').'</p>';
+	dcPage::message(__('Items have been successfully removed.'));
 }
 
 if (!empty($_GET['addlink'])) {
-		echo '<p class="message">'.__('Link has been successfully created.').'</p>';
+	dcPage::message(__('Link has been successfully created.'));
 }
 
 if (!empty($_GET['addcat'])) {
-		echo '<p class="message">'.__('category has been successfully created.').'</p>';
+	dcPage::message(__('category has been successfully created.'));
 }
 
 if (!empty($_GET['importlinks'])) {
-		echo '<p class="message">'.__('links have been successfully imported.').'</p>';
+	dcPage::message(__('links have been successfully imported.'));
 }
 ?>
Index: plugins/blowupConfig/_define.php
===================================================================
--- plugins/blowupConfig/_define.php	(revision 464)
+++ plugins/blowupConfig/_define.php	(revision 967)
@@ -16,5 +16,5 @@
 	/* Description*/		"Configure your Blowup Theme",
 	/* Author */			"Olivier Meunier",
-	/* Version */			'1.1',
+	/* Version */			'1.2',
 	array(
 		'permissions' =>	'admin'
Index: plugins/blowupConfig/index.php
===================================================================
--- plugins/blowupConfig/index.php	(revision 683)
+++ plugins/blowupConfig/index.php	(revision 907)
@@ -228,11 +228,10 @@
 
 if (!$can_write_images) {
-	echo '<div class="message">'.
-		__('For the following reasons, images cannot be created. You won\'t be able to change some background properties.').
-		$notices.'</div>';
+	dcPage::message(__('For the following reasons, images cannot be created. You won\'t be able to change some background properties.').
+		$notices,false,true);
 }
 
 if (!empty($_GET['upd'])) {
-	echo '<p class="message">'.__('Theme configuration has been successfully updated.').'</p>';
+	dcPage::message(__('Theme configuration has been successfully updated.'));
 }
 
Index: plugins/importExport/_define.php
===================================================================
--- plugins/importExport/_define.php	(revision 841)
+++ plugins/importExport/_define.php	(revision 967)
@@ -16,5 +16,5 @@
 	/* Description*/		"Import and Export your blog",
 	/* Author */			"Olivier Meunier & Contributors",
-	/* Version */			'3.1',
+	/* Version */			'3.2',
 	/* Perm */			'admin'
 );
Index: plugins/importExport/_prepend.php
===================================================================
--- plugins/importExport/_prepend.php	(revision 857)
+++ plugins/importExport/_prepend.php	(revision 891)
@@ -32,12 +32,12 @@
 function registerIeModules($modules)
 {
-	$modules['import'][] = 'dcImportFlat';
-	$modules['import'][] = 'dcImportFeed';
+	$modules['import'] = array_merge($modules['import'],array('dcImportFlat'));
+	$modules['import'] = array_merge($modules['import'],array('dcImportFeed'));
 	
-	$modules['export'][] = 'dcExportFlat';
+	$modules['export'] = array_merge($modules['export'],array('dcExportFlat'));
 	
 	if ($GLOBALS['core']->auth->isSuperAdmin()) {
-		$modules['import'][] = 'dcImportDC1';
-		$modules['import'][] = 'dcImportWP';
+		$modules['import'] = array_merge($modules['import'],array('dcImportDC1'));
+		$modules['import'] = array_merge($modules['import'],array('dcImportWP'));
 	}
 }
Index: plugins/importExport/inc/class.dc.import.feed.php
===================================================================
--- plugins/importExport/inc/class.dc.import.feed.php	(revision 840)
+++ plugins/importExport/inc/class.dc.import.feed.php	(revision 907)
@@ -77,5 +77,5 @@
 	{
 		if ($this->status) {
-			echo '<p class="message">'.__('Content successfully imported.').'</p>';
+			dcPage::message(__('Content successfully imported.'));
 		}
 		
Index: plugins/importExport/inc/class.dc.import.flat.php
===================================================================
--- plugins/importExport/inc/class.dc.import.flat.php	(revision 840)
+++ plugins/importExport/inc/class.dc.import.flat.php	(revision 939)
@@ -142,10 +142,10 @@
 		if ($this->status == 'single')
 		{
-			echo '<p class="message">'.__('Single blog successfully imported.').'</p>';
+			dcPage::message(__('Single blog successfully imported.'));
 			return;
 		}
 		if ($this->status == 'full')
 		{
-			echo '<p class="message">'.__('Content successfully imported.').'</p>';
+			dcPage::message(__('Content successfully imported.'));
 			return;
 		}
@@ -184,5 +184,6 @@
 		'<p>'.sprintf(__('This will import a single blog backup as new content in the current blog: %s.'),html::escapeHTML($this->core->blog->name)).'</p>'.
 		
-		'<p><label for="up_single_file">'.__('Upload a backup file').'</label>'.
+		'<p><label for="up_single_file">'.__('Upload a backup file').
+		' ('.sprintf(__('Maximum size %s'),files::size(DC_MAX_UPLOAD_SIZE)).')'.'</label>'.
 		'<input type="file" id="up_single_file" name="up_single_file" size="20" />'.
 		'</p>';
@@ -212,5 +213,6 @@
 			'<p>'.__('This will reset all the content of your database, except users.').'</p>'.
 			
-			'<p><label for="up_full_file">'.__('Upload a backup file').'</label>'.
+			'<p><label for="up_full_file">'.__('Upload a backup file').
+			' ('.sprintf(__('Maximum size %s'),files::size(DC_MAX_UPLOAD_SIZE)).')'.'</label>'.
 			'<input type="file" id="up_full_file" name="up_full_file" size="20" />'.
 			'</p>';
Index: plugins/importExport/inc/flat/class.flat.backup.php
===================================================================
--- plugins/importExport/inc/flat/class.flat.backup.php	(revision 841)
+++ plugins/importExport/inc/flat/class.flat.backup.php	(revision 894)
@@ -61,5 +61,5 @@
 		{
 			$line = preg_replace('/^"|"$/','',$line);
-			$line = preg_split('/(^"|","|"$)/m',$line);
+			$line = preg_split('/(^"|","|(?<!\\\)\"$)/m',$line);
 			
 			if (count($this->line_cols) != count($line)) {
Index: plugins/maintenance/_define.php
===================================================================
--- plugins/maintenance/_define.php	(revision 464)
+++ plugins/maintenance/_define.php	(revision 967)
@@ -16,5 +16,5 @@
 	/* Description*/		"Maintain your database",
 	/* Author */			"Olivier Meunier",
-	/* Version */			'1.1'
+	/* Version */			'1.2'
 );
 ?>
Index: plugins/maintenance/index.php
===================================================================
--- plugins/maintenance/index.php	(revision 500)
+++ plugins/maintenance/index.php	(revision 907)
@@ -73,14 +73,14 @@
 <?php
 if (!empty($_GET['vacuum'])) {
-	echo '<p class="message">'.__('Optimization successful.').'</p>';
+	dcPage::message(__('Optimization successful.'));
 }
 if (!empty($_GET['commentscount'])) {
-	echo '<p class="message">'.__('Comments and trackback counted.').'</p>';
+	dcPage::message(__('Comments and trackback counted.'));
 }
 if (!empty($_GET['empty_cache'])) {
-	echo '<p class="message">'.__('Templates cache directory emptied.').'</p>';
+	dcPage::message(__('Templates cache directory emptied.'));
 }
 if (!empty($_GET['delete_logs'])) {
-	echo '<p class="message">'.__('Logs deleted.').'</p>';
+	dcPage::message(__('Logs deleted.'));
 }
 
@@ -105,5 +105,5 @@
 	else
 	{
-		echo '<p class="message">'.__('Entries index done.').'</p>';
+		dcPage::message(__('Entries index done.'));
 		echo '<p><a class="back" href="'.$p_url.'">'.__('Back').'</a></p>';
 	}
@@ -129,5 +129,5 @@
 	else
 	{
-		echo '<p class="message">'.__('Comments index done.').'</p>';
+		dcPage::message(__('Comments index done.'));
 		echo '<p><a class="back" href="'.$p_url.'">'.__('Back').'</a></p>';
 	}
Index: plugins/pages/_define.php
===================================================================
--- plugins/pages/_define.php	(revision 464)
+++ plugins/pages/_define.php	(revision 965)
@@ -16,5 +16,5 @@
 	/* Description*/	"Serve entries as simple web pages",
 	/* Author */		"Olivier Meunier",
-	/* Version */		'1.1.1',
+	/* Version */		'1.2',
 	array(
 		'permissions' =>	'contentadmin,pages',
Index: plugins/pages/_public.php
===================================================================
--- plugins/pages/_public.php	(revision 727)
+++ plugins/pages/_public.php	(revision 945)
@@ -221,5 +221,6 @@
 		global $core, $_ctx;
 		
-		if ($w->homeonly && $core->url->type != 'default') {
+		if (($w->homeonly == 1 && $core->url->type != 'default') ||
+			($w->homeonly == 2 && $core->url->type == 'default')) {
 			return;
 		}
@@ -228,4 +229,5 @@
 		$params['limit'] = abs((integer) $w->limit);
 		$params['no_content'] = true;
+		$params['post_selected'] = false;
 		
 		$sort = $w->sortby;
@@ -247,5 +249,5 @@
 		
 		$res =
-		'<div class="pages">'.
+		'<div class="pages'.($w->class ? ' '.html::escapeHTML($w->class) : '').'">'.
 		($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').
 		'<ul>';
Index: plugins/pages/_widgets.php
===================================================================
--- plugins/pages/_widgets.php	(revision 270)
+++ plugins/pages/_widgets.php	(revision 954)
@@ -19,7 +19,13 @@
 	public static function initWidgets($w)
 	{
-		$w->create('pages',__('Pages'),array('tplPages','pagesWidget'));
+		$w->create('pages',__('Pages'),array('tplPages','pagesWidget'),null,'List of published pages');
 		$w->pages->setting('title',__('Title:'),__('Pages'));
-		$w->pages->setting('homeonly',__('Home page only'),1,'check');
+		$w->pages->setting('homeonly',__('Display on:'),1,'combo',
+			array(
+				__('All pages') => 0,
+				__('Home page only') => 1,
+				__('Except on home page') => 2
+				)
+		);
 		$w->pages->setting('sortby',__('Order by:'),'post_title','combo',
 			array(
@@ -32,4 +38,5 @@
 			array(__('Ascending') => 'asc', __('Descending') => 'desc')
 		);
+		$w->pages->setting('class',__('CSS class:'),'');
 	}
 	
Index: plugins/pages/list.php
===================================================================
--- plugins/pages/list.php	(revision 578)
+++ plugins/pages/list.php	(revision 911)
@@ -86,5 +86,5 @@
 		$selected = '';
 		if ($this->rs->post_selected) {
-			$selected = sprintf($img,__('selected'),'selected.png');
+			$selected = sprintf($img,__('hidden'),'hidden.png');
 		}
 		
Index: plugins/pages/page.php
===================================================================
--- plugins/pages/page.php	(revision 776)
+++ plugins/pages/page.php	(revision 957)
@@ -31,4 +31,5 @@
 $post_open_comment = false;
 $post_open_tb = false;
+$post_selected = false;
 
 $post_media = array();
@@ -76,4 +77,6 @@
 unset($rs);
 
+# Validation flag
+$bad_dt = false;
 
 # Get page informations
@@ -108,4 +111,5 @@
 		$post_open_comment = (boolean) $post->post_open_comment;
 		$post_open_tb = (boolean) $post->post_open_tb;
+		$post_selected = (boolean) $post->post_selected;
 		
 		$page_title = __('Edit page');
@@ -154,10 +158,22 @@
 		$post_dt = '';
 	} else {
-		$post_dt = strtotime($_POST['post_dt']);
-		$post_dt = date('Y-m-d H:i',$post_dt);
+		try
+		{
+			$post_dt = strtotime($_POST['post_dt']);
+			if ($post_dt == false || $post_dt == -1) {
+				$bad_dt = true;
+				throw new Exception(__('Invalid publication date'));
+			}
+			$post_dt = date('Y-m-d H:i',$post_dt);
+		}
+		catch (Exception $e)
+		{
+			$core->error->add($e->getMessage());
+		}
 	}
 	
 	$post_open_comment = !empty($_POST['post_open_comment']);
 	$post_open_tb = !empty($_POST['post_open_tb']);
+	$post_selected = !empty($_POST['post_selected']);
 	$post_lang = $_POST['post_lang'];
 	$post_password = !empty($_POST['post_password']) ? $_POST['post_password'] : null;
@@ -177,5 +193,5 @@
 
 # Create or update post
-if (!empty($_POST) && !empty($_POST['save']) && $can_edit_page)
+if (!empty($_POST) && !empty($_POST['save']) && $can_edit_page && !$bad_dt)
 {
 	$cur = $core->con->openCursor($core->prefix.'post');
@@ -200,4 +216,5 @@
 	$cur->post_open_comment = (integer) $post_open_comment;
 	$cur->post_open_tb = (integer) $post_open_tb;
+	$cur->post_selected = (integer) $post_selected;
 	
 	if (isset($_POST['post_url'])) {
@@ -297,14 +314,14 @@
 
 if (!empty($_GET['upd'])) {
-		echo '<p class="message">'.__('Page has been successfully updated.').'</p>';
+	dcPage::message(__('Page has been successfully updated.'));
 }
 elseif (!empty($_GET['crea'])) {
-		echo '<p class="message">'.__('Page has been successfully created.').'</p>';
+	dcPage::message(__('Page has been successfully created.'));
 }
 elseif (!empty($_GET['attached'])) {
-	echo '<p class="message">'.__('File has been successfully attached.').'</p>';
+	dcPage::message(__('File has been successfully attached.'));
 }
 elseif (!empty($_GET['rmattach'])) {
-	echo '<p class="message">'.__('Attachment has been successfully removed.').'</p>';
+	dcPage::message(__('Attachment has been successfully removed.'));
 }
 
@@ -316,5 +333,5 @@
 	$post_format = 'xhtml';
 	
-	echo '<p class="message">'.__('Don\'t forget to validate your XHTML conversion by saving your post.').'</p>';
+	dcPage::message(__('Don\'t forget to validate your XHTML conversion by saving your post.'));
 }
 
@@ -415,5 +432,5 @@
 	
 	'<p><label for="post_dt">'.__('Published on:').
-	form::field('post_dt',16,16,$post_dt).'</label></p>'.
+	form::field('post_dt',16,16,$post_dt,($bad_dt ? 'invalid' : '')).'</label></p>'.
 	
 	'<p><label for="post_format">'.__('Text formating:').
@@ -424,7 +441,24 @@
 	'<p><label for="post_open_comment" class="classic">'.form::checkbox('post_open_comment',1,$post_open_comment).' '.
 	__('Accept comments').'</label></p>'.
+	($core->blog->settings->system->allow_comments ? 
+		(isContributionAllowed($post_id,strtotime($post_dt),true) ? 
+			'' :
+			'<p class="form-note warn">'.__('Warning: Comments are not more accepted for this page.').'</p>') : 
+		'<p class="form-note warn">'.__('Warning: Comments are not accepted on this blog.').'</p>').
+
 	'<p><label for="post_open_tb" class="classic">'.form::checkbox('post_open_tb',1,$post_open_tb).' '.
 	__('Accept trackbacks').'</label></p>'.
-	
+	($core->blog->settings->system->allow_trackbacks ? 
+		(isContributionAllowed($post_id,strtotime($post_dt),false) ? 
+			'' :
+			'<p class="form-note warn">'.__('Warning: Trackbacks are not more accepted for this page.').'</p>') : 
+		'<p class="form-note warn">'.__('Warning: Trackbacks are not accepted on this blog.').'</p>').
+	
+	'<p><label for="post_selected" class="classic">'.form::checkbox('post_selected',1,$post_selected).' '.
+	__('Hidden').'</label></p>'.
+	'<p class="form-note">'.
+	__('If checked this page will be active but not listed in widget Pages.').
+	'</p>'.
+
 	'<p><label for="post_position" class="classic">'.__('Page position:').' '.
 	form::field('post_position',3,3,(string) $post_position).
@@ -603,4 +637,25 @@
 }
 
+# Controls comments or trakbacks capabilities
+function isContributionAllowed($id,$dt,$com=true)
+{
+	global $core;
+
+	if (!$id) {
+		return true;
+	}
+	if ($com) {
+		if (($core->blog->settings->system->comments_ttl == 0) || 
+			(time() - $core->blog->settings->system->comments_ttl*86400 < $dt)) {
+			return true;
+		}
+	} else {
+		if (($core->blog->settings->system->trackbacks_ttl == 0) || 
+			(time() - $core->blog->settings->system->trackbacks_ttl*86400 < $dt)) {
+			return true;
+		}
+	}
+	return false;
+}
 
 # Show comments or trackbacks
Index: plugins/pings/_define.php
===================================================================
--- plugins/pings/_define.php	(revision 464)
+++ plugins/pings/_define.php	(revision 967)
@@ -16,5 +16,5 @@
 	/* Description*/		"Ping services",
 	/* Author */			"Olivier Meunier",
-	/* Version */			'1.1',
+	/* Version */			'1.2',
 	array(
 		'permissions' =>	'usage,contentadmin'
Index: plugins/pings/index.php
===================================================================
--- plugins/pings/index.php	(revision 500)
+++ plugins/pings/index.php	(revision 907)
@@ -54,5 +54,5 @@
 
 if (!empty($_GET['up'])) {
-	echo '<p class="message">'.__('Settings have been successfully updated.').'</p>';
+	dcPage::message(__('Settings have been successfully updated.'));
 }
 
Index: plugins/simpleMenu/_define.php
===================================================================
--- plugins/simpleMenu/_define.php	(revision 685)
+++ plugins/simpleMenu/_define.php	(revision 967)
@@ -16,5 +16,5 @@
 	/* Description*/		"Simple menu for Dotclear",
 	/* Author */			"Franck Paul",
-	/* Version */			'1.0',
+	/* Version */			'1.1',
 	array(
 		'permissions' =>	'admin'
Index: plugins/simpleMenu/_public.php
===================================================================
--- plugins/simpleMenu/_public.php	(revision 683)
+++ plugins/simpleMenu/_public.php	(revision 945)
@@ -42,5 +42,6 @@
 		global $core, $_ctx;
 		
-		if ($w->homeonly && $core->url->type != 'default') {
+		if (($w->homeonly == 1 && $core->url->type != 'default') ||
+			($w->homeonly == 2 && $core->url->type == 'default')) {
 			return;
 		}
@@ -51,5 +52,7 @@
 		}
 
-		return '<div class="simple-menu">'.($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').$menu.'</div>';
+		return '<div class="simple-menu'.
+			($w->class ? ' '.html::escapeHTML($w->class) : '').'">'.
+			($w->title ? '<h2>'.html::escapeHTML($w->title).'</h2>' : '').$menu.'</div>';
 	}
 	
Index: plugins/simpleMenu/_widgets.php
===================================================================
--- plugins/simpleMenu/_widgets.php	(revision 587)
+++ plugins/simpleMenu/_widgets.php	(revision 954)
@@ -18,7 +18,14 @@
 	public static function initWidgets($w)
 	{
-		$w->create('simplemenu',__('Simple menu'),array('tplSimpleMenu','simpleMenuWidget'));
+		$w->create('simplemenu',__('Simple menu'),array('tplSimpleMenu','simpleMenuWidget'),null,'List of simple menu items');
 		$w->simplemenu->setting('title',__('Title:'),__('Menu'));
-		$w->simplemenu->setting('homeonly',__('Home page only'),1,'check');
+		$w->simplemenu->setting('homeonly',__('Display on:'),0,'combo',
+			array(
+				__('All pages') => 0,
+				__('Home page only') => 1,
+				__('Except on home page') => 2
+				)
+		);
+		$w->simplemenu->setting('class',__('CSS class:'),'');
 	}
 }
